<template>
  <page
    class="flex-grow-1"
    id="find_person"
    title="Encontrar Pessoa"
  >
    <v-text-field
      outlined="outlined"
      prepend-inner-icon="mdi-magnify"
      v-model="search"
      label="Buscar Pessoa"
    />
    <v-list two-line="two-line">
      <v-skeleton-loader
        v-if="$apollo.queries.persons.loading"
        type="list-item-two-line"
      />
      <v-list-item v-else-if="(!persons || persons.length === 0)">
        <v-list-item-content>
          <v-list-item-title>No results found!</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <template v-else>
        <v-list-item
          v-for="person in persons"
          :key="person.id"
        >
          <v-list-item-content>
            <v-list-item-title>{{person.fullname}}</v-list-item-title>
            <v-list-item-subtitle>{{person.document && `${person.document.type} - ${person.document.value}`}}</v-list-item-subtitle>
          </v-list-item-content>
          <v-list-item-action>
            <v-btn
              icon="icon"
              @click="openDialog(person.id)"
            >
              <v-icon>mdi-information</v-icon>
            </v-btn>
          </v-list-item-action>
          <v-list-item-action>
            <v-btn
              icon="icon"
              @click="openScanner(person.id)"
            >
              <v-icon>mdi-qrcode</v-icon>
            </v-btn>
          </v-list-item-action>
        </v-list-item>
      </template>
    </v-list>
    <!-- Pagination -->
    <v-pagination />

    <!-- Person Info dialog-->
    <person-info-dialog
      :id="dialogID"
      v-model="infoDialog"
    />
    <!-- Card Scanner dialog-->
    <card-scanner-dialog
      :id="scannerID"
      v-model="scannerDialog"
    />
  </page>
</template>

<script>
import Page from '@/components/Page.vue'

import listPersonsQuery from '@/gql/PersonList.gql'
import listPersonsSubscription from '@/gql/PersonListSubscription.gql'

// Dialogs
import PersonInfoDialog from '@/components/dialogs/PersonInfo.vue'
import CardScannerDialog from '@/components/dialogs/CardScanner.vue'

export default {
  name: 'PersonsPage',
  components: { Page, PersonInfoDialog, CardScannerDialog },
  data: () => ({
    search: null,

    dialogID: null,
    infoDialog: false,

    scannerID: null,
    scannerDialog: false
  }),
  apollo: {
    persons: {
      query: listPersonsQuery,
      variables () {
        return {
          filter: {
            search: this.search
          }
        }
      },
      subscribeToMore: {
        document: listPersonsSubscription,
        updateQuery: (previousResult, { subscriptionData }) => {
          return subscriptionData.data
        },
        variables () {
          return {
            filter: {
              search: this.search
            }
          }
        }
      }
    }
  },
  methods: {
    openDialog (id) {
      this.dialogID = id
      this.infoDialog = true
    },
    openScanner (id) {
      this.scannerID = id
      this.scannerDialog = true
    }
  }
}
</script>
